
Program EASYDATE ;
uses DOS,CRT ;

Const
  posn : array[1..9] of integer = (4,6,7,10,12,15,19,24,29) ;
     { cursor positions for each selection }
  days : array[1..12] of word = (31,28,31,30,31,30,31,31,30,31,30,31) ;
     { the number of days in each month }
  double : string[31] = ('') ;
     { text bar for use in display }
Var
  DT : DateTime ;
     { Variable to Hold Date & Time }
  exitCode : byte ;
     { holds the exit condition 1 for normal 2 for abort }
  tmp,seconds,select : word ;
  fle : text ;
  running : boolean ;

procedure GetOldTime (var DT : DateTime ) ;
   { Retrives the old time from the File }
var
  file_Time : longint ;

begin
  assign (fle,ParamStr(0)) ;
  GetDate (DT.year,DT.month,DT.day,tmp) ;
  if DT.year = 1980 then begin
    running := false ;
    reset (fle) ;
    GetFTime (fle,file_Time) ;
    unpacktime (file_Time,DT) ;
    close (fle) ;
  end Else Begin
    GetTime (DT.hour,DT.min,DT.sec,tmp) ;
    running := true ;
  end ;
end ;

procedure SetNewTime (DT : DateTime) ;
   { Stamps the file with the new date & time }
var
  file_Time : longint ;
begin
  setTime (DT.hour,DT.min,DT.sec,0) ;
  setDate (DT.year,DT.month,DT.day) ;
  DT.sec := 0 ;
  PackTime (DT,file_Time) ;
  reset (fle) ;
  SetFTime (fle,file_Time) ;
  close (fle) ;
end ;

procedure display (DT :DateTime) ;
const
   day_label : array[0..6] of string[3] = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat') ;
      { text for display }
   month_label : array[1..12] of string[3] = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec') ;
      { text for display }
Var
   weekday :word ;


   Procedure GetWeekday (yy,mm,dd:word ; Var vday:word);
      var tmp,century:word;
      begin
         if mm <3 then mm:=mm+10
            else mm:=mm-2;
         if mm>10 then yy:=yy-1;
         century:= yy div 100;
         yy:=yy mod 100;
         tmp:=trunc(2.6*mm-0.2)+dd+yy+(yy div 4)+(century div 4)-(2*century);
         vday:=(tmp+777) mod 7;
      end;

Begin
   if DT.hour = 0 then write ('12') else begin
      if (DT.hour < 10) or ((DT.hour < 22) and (DT.hour > 12 )) then write (' ') ;
      if DT.hour > 12 then write (DT.hour-12) else write (DT.hour) ;
   end ;
   write (':') ;
   if DT.min < 10 then write ('0') ;
   write (DT.min,':') ;
   if DT.sec < 10 then write ('0') ;
   write (DT.sec) ;
   if DT.hour > 11 then write (' PM') else write (' AM') ;
   GetWeekDay (DT.year,DT.month,DT.day,weekday) ;
   write (' ',day_label[weekday],' ',month_label[DT.month],' ',DT.day:2,' ',DT.year:4) ;
   GotoXY (Posn[select],wherey) ;
End ;

Procedure ChangeTime (Var DT :DateTime)  ;
   Var
      ch : char ;
      old : word ;    { stores the old seconds entry }

   Procedure Up (select : integer) ; forward ;
   Procedure Down (select : integer) ; forward ;

   Procedure day (dir : boolean) ;
      Begin

         { Take care of all normal months including FEB with 28 days }
         if dir then
            if DT.day = Days[DT.month] then begin
               DT.day := 1 ;
               Up(7) ;
            end else inc (DT.day)
         else
            if DT.day = 1 then begin
               Down(7) ;
               DT.day := Days[DT.month]
            end else dec(DT.day) ;
      End ;

   Procedure Up (select:integer);

   Begin
      Case Select of
         1 : if DT.hour = 23 then DT.hour := 0 else inc (DT.hour) ;
         2 : if DT.min > 49 then DT.min := DT.min - 50 else DT.min := DT.min +10 ;
         3 : if (DT.min) = 59 then DT.min := 0 else inc(DT.min) ;
         4 : if DT.sec = 59 then DT.sec := 0 else inc (DT.sec) ;
         5 : if DT.hour < 12 then DT.hour := DT.hour +12 else DT.hour := DT.hour-12 ;
         6 : day (true) ;
         7 : if DT.month = 12 then begin
                up (9) ;
                DT.month := 1 ;
             end else inc (DT.month) ;
         8 : day (true) ;
         9 : inc (DT.year) ;
      End ;
   End ;

   Procedure Down (select:integer) ;
   Begin
      Case select of
         1 : if DT.hour = 0 then DT.hour := 23 else dec (DT.hour) ;
         2 : if DT.min < 10 then DT.min := DT.min + 50 else DT.min := DT.min - 10 ;
         3 : if (DT.min) = 0 then DT.min :=59 else dec (DT.min) ;
         4 : if DT.sec = 0 then DT.sec := 59 else dec (DT.sec) ;
         5 : if DT.hour < 12 then Dt.hour := Dt.hour +12 else DT.hour := Dt.hour -12 ;
         6 : day (false) ;
         7 : if DT.month = 1 then Begin
                Down (9) ;
                DT.month := 12 ;
             end else dec (DT.month) ;
         8 : day (false) ;
         9 : dec (DT.year) ;
      End ;
   End ;

   Procedure Slider ( select : integer ) ;
   Begin
      gotoxy (1,wherey-1) ;
      write (copy(double,1,posn[select]-2),' ',chr(24),' ',copy(double,1,31-posn[select]-1)) ;
      gotoxy (1,wherey+2) ;
      write (copy(double,1,posn[select]-2),' ',chr(25),' ',copy(double,1,31-posn[select]-1)) ;
      gotoxy (1,wherey-1);
   End ;

procedure HelpScreen ;
var ch : char ;
begin
   window (1,1,79,7) ;
   clrscr ;
   writeln ('             EasyDate Version 4.22  Freeware  (C)1989,1990 Brian Evans') ;
   writeln ;
   writeln (' [ESC] Abort & Return to DOS        Up          [TAB] Toggle between Date/Time') ;
   writeln ('                               [+] [=] [',chr(24),']' ) ;
   writeln ('             [<] [,] [',chr(27),']  Left             Right  [SPC] [',chr(26),'] [.] [>]') ;
   writeln ('                               [-] [_] [',chr(25),']' ) ;
   write   (' [F1] [?] [/] Help                 Down               [R] Toggle running clock' ) ;
   window (1,17,80,25) ;
   clrscr ;
   writeln ;
   writeln ('  Please send any suggestions                        Brian Evans') ;
   writeln ('  , bug reports etc to the                           56 Hilda Street') ;
   writeln ('  author either by normal mail                       Petawawa , Ontario') ;
   writeln ('  or E-MAIL on Compuserve.                           K8H 2Z5') ;
   writeln ('        THANK YOU                                    Canada' );
   writeln ;
   writeln ('                   On Compuserve send E-MAIL to : 72210,3146') ;
   window (24,11,55,14) ;
end ;

procedure Toggle ;
begin
   if running then begin
     running := false ;
     DT.sec := 0 ;
   end else begin
     running := true ;
   end ;
end ;

Begin
      clrscr ;
         window (23,9,55,15) ;
         textbackground (BLUE) ;
         textcolor (black) ;
         clrscr ;
         writeln ;
         window (24,10,55,14) ;
      writeln ('        EASYDATE V4.22');
      textcolor (yellow) ;
   old := 0 ;
   If ParamCount >0 then
      for tmp := 1 to ParamCount do begin
         if ParamStr (1) = 'r' then running := true ;
         if ParamStr (1) = '-r' then running := false ;
      end ;
   select := 1 ;
   writeln ;
   writeln (chr(27),'                             ',chr(26)) ;
   writeln ;
   textcolor (black) ;
   write(' (C)1989 Brian Evans  [?] Help');
   textcolor (yellow) ;
   gotoxy (wherex,wherey-2) ;
   while (exitCode=0) do begin
      slider (select) ;
      gotoxy (3,wherey) ;
      display (DT) ;
      if running then
         while not(keypressed) do begin
            GetTime (tmp,tmp,seconds,tmp) ;
            if seconds <> old then begin
               old := seconds ;
               gotoxy (3,wherey) ;
               if (DT.sec = 59) and (DT.min = 59) and (DT.hour = 23) then up(6) ;
               if (DT.sec = 59) and (DT.min = 59) then up(1) ;
               if (DT.sec = 59) then up(3) ;
               up(4) ;
               display (DT) ;
            end ;
         end ;
      ch := readkey ;
      if ch = #0 then ch := readkey ;
      Case ch of
         #09 : if select<6 then select:=6 else select:=1 ;
         #72,'+','=' : UP(select) ;
         #80,'-','_' : Down(select) ;
         #77,#32,'.','>' : if select=9 then select:=1 else inc(select) ;
         #75,',','<' : if select=1 then select:=9 else dec(select) ;
         #27 : exitCode := 2 ;
         #13 : exitCode := 1 ;
         #59,#63,'/' : HelpScreen ;
         'r','R' : Toggle ;
      End ;
   End ;
   normvideo ;
   window (1,1,80,25) ;
   clrscr ;
End ;

Begin
   exitCode := 0 ;
   GetOldTime (DT) ;
   ChangeTime (DT) ;
   if exitCode=1 then SetNewTime (DT) ;
End.

